#define _GNU_SOURCE
#include <stdint.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <sys/mman.h>
#include <TSC_ADC.h>

volatile uint32_t *TSC_ADC;

#define CM_WKUP_ADC_TSC_CLKCTRL  0x44E004BC

_Bool bbb_adc_init(void){
    int dev;
    if((dev = open("/dev/mem", O_RDWR|O_SYNC|O_LARGEFILE)) < 0){
        perror("open");
        return(1);
    }

    volatile uint32_t *mem;
    if((mem = mmap(0, CM_WKUP_ADC_TSC_CLKCTRL, PROT_READ | PROT_WRITE, MAP_SHARED, dev, 0)) == MAP_FAILED){
        perror("Err: Can not map CM_WKUP registers.");
        return(1);
    }
    mem[CM_WKUP_ADC_TSC_CLKCTRL/sizeof(uint32_t)] = 0x02;
    munmap((void *)mem, CM_WKUP_ADC_TSC_CLKCTRL);

    if((TSC_ADC = mmap(0, AM335x_TSC_ADC_LEN, PROT_READ | PROT_WRITE, MAP_SHARED, dev, AM335x_TSC_ADC_ADDR)) == MAP_FAILED){
        perror("Err: Can not map TSC_ADC registers.");
        return(1);
    }

    close(dev);
    return(0);
}

_Bool bbb_adc_free(void){
    munmap((void *)TSC_ADC, AM335x_TSC_ADC_LEN);
    return(0);
}

